<%@ page import="org.wso2.registry.web.actions.ResourceDetailsAction" %>
<%@ page import="org.wso2.registry.web.actions.CollectionViewAction" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="org.wso2.registry.web.actions.utils.ResourceData" %>
<%@ page import="org.wso2.registry.web.UIConstants" %>
<%@ page import="org.wso2.registry.web.actions.utils.VersionPath" %>
<%@ page import="org.wso2.registry.Tag" %>
<%@ page import="org.wso2.registry.Comment" %>
<%@ page import="org.wso2.registry.web.actions.utils.ResourcePath" %>
<%@ page import="java.util.List" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
"http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
    <script language="JavaScript" type="text/JavaScript" src="/wso2registry/admin/js/common.js"></script>
    <script language="JavaScript" type="text/JavaScript" src="/wso2registry/admin/js/prototype.js"></script>
    <link type="text/css" href="/wso2registry/admin/css/main.css" rel="stylesheet" />
    <title>WSO2 Registry</title>
</head>
<body onload="loadMediaTypes()">

<div class="page-sizer">
<!-- START header content -->

<%
    ResourceDetailsAction details = (ResourceDetailsAction) request.getSession().getAttribute(UIConstants.RESOURCE_BEAN);
    CollectionViewAction collection = (CollectionViewAction) request.getSession().getAttribute(UIConstants.COLLECTION_BEAN);

    String errorMessage = (String) request.getSession().getAttribute(UIConstants.ERROR_MESSAGE);
    if (errorMessage != null) {
        request.getSession().setAttribute(UIConstants.ERROR_MESSAGE, null);
    }
%>

<jsp:include page="header.jsp" />

<! START body content -->
<div class="content">
<h1 class="headding-registryResources">Registry Resources</h1>
<% if (errorMessage != null) { %>
<div><%=errorMessage%></div>
<% } %>
<div class="breadcrumb">
    <%
        List iNavPaths = details.getNavigatablePaths();
        if (iNavPaths.size() > 0) {
            ResourcePath rootPath = (ResourcePath) iNavPaths.get(0);
            %>
            <a href="/wso2registry/web<%=rootPath.getNavigatePath()%>"><%=rootPath.getNavigateName()%></a>
            <%

            if (iNavPaths.size() > 1) {
                ResourcePath childPath = (ResourcePath) iNavPaths.get(1);
                %>
                <a href="/wso2registry/web<%=childPath.getNavigatePath()%>"><%=childPath.getNavigateName()%></a>
                <%
            }

            if (iNavPaths.size() > 2) {
                for (int i = 2; i < iNavPaths.size(); i++) {
                    ResourcePath resourcePath = (ResourcePath) iNavPaths.get(i);
                    %>
                    /<a href="/wso2registry/web<%=resourcePath.getNavigatePath()%>"><%=resourcePath.getNavigateName()%></a>
                <% }
            }
        } %>
</div>
<table cellpadding="0" cellspacing="0" border="0">
<tr>
<td style="width:700px;" valign="top">

<!-- Display the details of main node -->
<div class="resource-head">
    <% if (details.isCollection()) { %>
    <div class="folder-small headding1"><%=details.getName()%></div>
    <% } else { %>
    <div class="resource-small headding1"><%=details.getName()%></div>
    <% } %>

    <table cellpadding="0" cellspacing="0" border="0" style="width:100%">
        <tr>
            <td>
                <div><strong>Created: </strong><%=details.getCreatedOn().toString()%><strong> Author: </strong><%=details.getAuthor()%></div>
                <div><strong>Last Updated: </strong><%=details.getLastModified().toString()%><strong> By:</strong><%=details.getLastUpdater()%></div>
            </td>
            <td align="right">
                <div id="ratingDiv"><img src="/wso2registry/admin/images/ajax-loader.gif" /></div>
            </td>
        </tr>
    </table>
</div>

<script type="text/javascript" xml:space="preserve">
    new Ajax.Updater('ratingDiv', '/wso2registry/system/getInitialRating', { method: 'get', parameters: {resourcePath: '<%=details.getPath()%>'} });
</script>

<div class="resource-content" id="descView" style="display:block;">
    description...
</div>
<textarea class="resource-content" id="descEdit" style="display:none; width:98%;height:200px;">
    description...
</textarea>

<script type="text/javascript" xml:space="preserve">
    new Ajax.Updater('descView', '/wso2registry/system/getDescription', { method: 'get', parameters: {resourcePath: '<%=details.getPath()%>'} });
    document.getElementById('descEdit').textContent = document.getElementById('descView').innerHTML;
</script>

<div class="resource-footer">
    <input id="editButton" type="button" class="button" value="Edit Description" onclick="processDescription()" />
</div>

<% if (details.isCollection()) { %>

<h2>Sub Items</h2>

<% if (details.isPutAllowed()) { %>

<table cellpadding="0" cellspacing="0" border="0">
    <tr>
        <td valign="top">
            <a href="#" class="add-resource" onclick="showHide('add-resource-div')">Add Resource</a>
        </td>

        <td valign="top"><a href="#" class="add-folder" onclick="showHide('add-folder-div')">Add Folder</a></td>
    </tr>
</table>

<% } %>

<!-- Add resource div -->
<div class="add-resource-div" id="add-resource-div" style="display:none;">
    <form method="post" name="resourceupload" id="resourceupload" action="/wso2registry/system/addResource"
          enctype="multipart/form-data">

        <input type="hidden" name="path" value="<%=details.getPath()%>"/>

        <table width="100%"  border="0" cellspacing="0" cellpadding="0">
            <tr>
                <td width="100" valign="top">Name</td>

                <td><input id="resourceName" type="text" name="filename" style="margin-bottom:10px;"/></td>
            </tr>
            <tr>
                <td width="100" valign="top">Media type</td>

                <td><input id="resourceMediaType" type="text" name="mediaType" style="margin-bottom:10px;"/></td>
            </tr>
            <tr>
                <td valign="top">Description</td>
                <td><textarea name="description" class="normal-textarea"></textarea></td>
            </tr>
            <tr>
                <td valign="top">File</td>
                <td><input id="resourceFile" type="file" name="upload" onchange="fillResourceDetails()"/></td>
            </tr>
            <tr>
                <td>&nbsp;</td>
                <td><input type="submit" class="button" value="Add" style="margin-top:10px;" onclick="showHide('add-resource-div')"/> <input type="submit" class="button" value="Cancel" style="margin-top:10px;" onclick="showHide('add-resource-div')"/></td>
            </tr>
        </table>
    </form>
</div>



<!-- Add folder div -->
<div class="add-resource-div" id="add-folder-div" style="display:none;">
    <form name="collectionForm" method="post" action="/wso2registry/system/addCollection">
        <input type="hidden" name="parentPath" value="<%=details.getPath()%>"/>
        <table width="100%"  border="0" cellspacing="0" cellpadding="0">
            <tr>
                <td width="100" valign="top">Name</td>

                <td><input type="text" name="collectionName" style="margin-bottom:10px;"/></td>
            </tr>
            <tr>
                <td valign="top">Media Type</td>
                <td><input type="text" name="mediaType" style="margin-bottom:10px;"/></td>
            </tr>
            <tr>
                <td valign="top">Description</td>
                <td><textarea name="description" class="normal-textarea"></textarea></td>
            </tr>
            <tr>
                <td>&nbsp;</td>
                <td><input type="submit" class="button" value="Add" style="margin-top:10px;" onclick="showHide('add-folder-div')"/> <input type="submit" class="button" value="Cancel" style="margin-top:10px;" onclick="showHide('add-folder-div')"/></td>
            </tr>
        </table>
    </form>
</div>



<table cellpadding="0" cellspacing="0" border="0" style="width:100%" class="data-table">
    <tr>
        <th></th>
        <th>Created Date</th>
        <th>Author</th>
        <th>Rating</th>
        <th>Description</th>
        <th>Action</th>

    </tr>
    <%
        Iterator iterator = collection.getResourceDataList().iterator();
        while (iterator.hasNext()) {
            ResourceData resourceData = (ResourceData) iterator.next();
    %>
    <tr id="1">
        <td><% if (resourceData.getResourceType() == ResourceData.COLLECTION) { %><a href="/wso2registry/web/<%=resourceData.getRelativePath()%>" class="folder-small"><%=resourceData.getName()%></a><% } else { %><a href="/wso2registry/web/<%=resourceData.getRelativePath()%>" class="resource-small"><%=resourceData.getName()%></a><% } %></td>
        <td><%=resourceData.getCreatedOn()%></td>
        <td><%=resourceData.getAuthorUserName()%></td>
        <td>
            <img src="/wso2registry/admin/images/r<%=resourceData.getAverageStars()[0]%>.gif"  />
            <img src="/wso2registry/admin/images/r<%=resourceData.getAverageStars()[1]%>.gif"  />
            <img src="/wso2registry/admin/images/r<%=resourceData.getAverageStars()[2]%>.gif"  />
            <img src="/wso2registry/admin/images/r<%=resourceData.getAverageStars()[3]%>.gif"  />
            <img src="/wso2registry/admin/images/r<%=resourceData.getAverageStars()[4]%>.gif"  />
            (<%=resourceData.getAverageRating()%>)
        </td>
        <td><a href="#" onclick="showDescription('1-des')"><img border="0" src="/wso2registry/admin/images/icon-show.gif" /></a></td>
        <td>
            <a href="#" title="Sub Items"><img src="/wso2registry/admin/images/icon-subitems.gif" border="0" /></a>
            <a href="#" title="Show Details" style="margin-left:5px;"><img src="/wso2registry/admin/images/icon-details.gif" border="0" /></a>
            <a href="/wso2registry/system/deleteResource?resourcePath=<%=resourceData.getResourcePath()%>" title="Delete" style="margin-left:5px;"><img src="/wso2registry/admin/images/icon-trash.gif" border="0" /></a>
        </td>

    </tr>
    <tr id="1-des" style="display:none;">
        <td colspan="6" class="table-description">
            <%=resourceData.getDescription()%>
        </td>
    </tr>

    <% } %>

</table>

<% } else { %>

<br/>
<a href="/wso2registry/web<%=details.getContentPath()%>">Download</a>
<br/>

<% } %>

<!-- Listing Comments -->

<h2>Comments</h2>

<!-- START comment box -->
<%
    Iterator iComments = details.getComments().iterator();
    while (iComments.hasNext()) {
        Comment comment = (Comment) iComments.next();
%>
<div class="comments-header">
    <strong>Commented on </strong><%=comment.getCommentedTime().toString()%><strong> by</strong> <a href="#"><%=comment.getCommentedUser()%></a>
    <div class="comments-bottom">
        <%=comment.getCommentText()%>
    </div>
</div>

<% } %>
<!-- END comment box -->

<h3>Add Comment</h3>

<!-- START add comment box -->
<div id="add-comment-div">
    <form action="/wso2registry/system/addComment" method="post">
        <textarea name="comment" class="comment-textbox"></textarea>
        <div style="margin-top:10px;"><input type="submit" class="button" value="Add" /> <input type="submit" class="button" value="Cancel" /></div>
    </form>
</div>
<!-- END add comment box -->

<h2>Permisions </h2>
<jsp:include page="permisions.jsp" />

</td>
<td valign="top" style="padding-left:10px;padding-right:10px;">

    <div class="title-heading">Tags</div>
    <div class="cloude-text">
        <%
            Iterator iTags = details.getTags().iterator();
            while (iTags.hasNext()) {
                Tag tag = (Tag) iTags.next();
        %>
        <a href="#" class="cloud-x<%=tag.getCategary()%>"><%=tag.getTagName()%></a>
        <% } %>
    </div>

    <form action="/wso2registry/system/tag" method="post">
        <table cellpadding="0" cellspacing="0" border="0" style="width:100%" class="form-table">
            <tr>
                <td>
                    <input type="text" name="tag" />
                </td>
                <td align="right">
                    <input type="submit" class="button" value="Add Tag" />
                </td>
            </tr>
            <tr>
                <td style="font-style:italic;" colspan="2">
                    <img src="/wso2registry/admin/images/help-small.jpg" style="margin-right:5px;" />Space seperate to add multiple tags.
                </td>
            </tr>
        </table>
    </form>

    <div class="title-heading" style="margin-top:5px;">Versions</div>




    <div class="resource-content">
        <%
            Iterator iVersions = details.getVersionPaths().iterator();
            while (iVersions.hasNext()) {
                VersionPath versionPath = (VersionPath) iVersions.next();
        %>

        <h3>Version <%=versionPath.getVersionNumber()%></h3>

        <strong style="color:#696969;">Last Modified:</strong><br>
        <%=versionPath.getUpdatedOn().toString()%>
        <br><strong style="color:#696969;">By:</strong> <%=versionPath.getUpdater()%>
        <br>
        <div style="margin-bottom:10px;">
            <a href="/wso2registry/web<%=versionPath.getCompleteVersionPath()%>" title="Details">Details <img src="/wso2registry/admin/images/icon-details.gif" border="0" hspace="3" /></a>
            <a href="#" title="Restore" style="margin-left:5px;">Restore <img src="/wso2registry/admin/images/icon-restore.gif" border="0" /></a>
        </div>


        <% } %>
    </div>

</td>
</tr>
</table>
</div>

<!-- START footer content -->
<jsp:include page="footer.jsp" />

</div>

</body>
</html>
